%define build_apr_dbd_ldap 1
%define build_apr_dbd_freetds 1
%define build_apr_dbd_mysql 1
%define build_apr_dbd_oracle 0
%define build_apr_dbd_pgsql 1
%define build_apr_dbd_sqlite3 1
%define build_apr_dbd_odbc 1
%define build_apr_dbm_db 1

%{?_with_apr_dbd_ldap: %{expand: %%global build_apr_dbd_ldap 1}}
%{?_without_apr_dbd_ldap: %{expand: %%global build_apr_dbd_ldap 0}}
%{?_with_apr_dbd_freetds: %{expand: %%global build_apr_dbd_freetds 1}}
%{?_without_apr_dbd_freetds: %{expand: %%global build_apr_dbd_freetds 0}}
%{?_with_apr_dbd_mysql: %{expand: %%global build_apr_dbd_mysql 1}}
%{?_without_apr_dbd_mysql: %{expand: %%global build_apr_dbd_mysql 0}}
%{?_with_apr_dbd_oracle: %{expand: %%global build_apr_dbd_oracle 1}}
%{?_without_apr_dbd_oracle: %{expand: %%global build_apr_dbd_oracle 0}}
%{?_with_apr_dbd_pgsql: %{expand: %%global build_apr_dbd_pgsql 1}}
%{?_without_apr_dbd_pgsql: %{expand: %%global build_apr_dbd_pgsql 0}}
%{?_with_apr_dbd_sqlite3: %{expand: %%global build_apr_dbd_sqlite3 1}}
%{?_without_apr_dbd_sqlite3: %{expand: %%global build_apr_dbd_sqlite3 0}}
%{?_with_apr_dbd_odbc: %{expand: %%global build_apr_dbd_odbc 1}}
%{?_without_apr_dbd_odbc: %{expand: %%global build_apr_dbd_odbc 0}}
%{?_with_apr_dbm_db: %{expand: %%global build_apr_dbm_db 1}}
%{?_without_apr_dbm_db: %{expand: %%global build_apr_dbm_db 0}}

%define apuver 1
%define major 0
%define libname %mklibname apr-util %{apuver} %{major}
%define develname %mklibname -d apr-util

Summary:        Apache Portable Runtime Utility library
Name:           apr-util
Version:        1.5.4
Release:        %mkrel 4
License:        Apache License
Group:          System/Libraries
URL:            http://apr.apache.org/
Source0:        http://www.apache.org/dist/apr/apr-util-%{version}.tar.bz2
Source1:        http://www.apache.org/dist/apr/apr-util-%{version}.tar.bz2.asc
Patch0:         apr-util-1.4.1-config.diff
Patch1:         apr-util-1.2.7-link.diff
Patch2:         apr-util-1.3.12-linkage_fix.diff
BuildRequires:  apr-devel >= 1:1.4.5
BuildRequires:  autoconf2.5
BuildRequires:  automake
BuildRequires:  doxygen
BuildRequires:  expat-devel
BuildRequires:  libtool
BuildRequires:  libxslt-devel
BuildRequires:  nss-devel
BuildRequires:  nspr-devel
BuildRequires:  openssl-devel
BuildRequires:  pam-devel
BuildRequires:  python
BuildRequires:  readline-devel
BuildRequires:  termcap-devel
%if %{build_apr_dbd_ldap}
BuildRequires:  openldap-devel
BuildRequires:  db-devel
%endif
%if %{build_apr_dbd_freetds}
BuildRequires:  freetds-devel
%endif
%if %{build_apr_dbd_mysql}
BuildRequires:  mysql-devel
%endif
%if %{build_apr_dbd_oracle}
BuildRequires:  oracle-devel
%endif
%if %{build_apr_dbd_pgsql}
BuildRequires:  postgresql-devel
%endif
%if %{build_apr_dbd_sqlite3}
BuildRequires:  sqlite3-devel
%endif
%if %{build_apr_dbd_odbc}
BuildRequires:  unixODBC-devel
%endif
%if %{build_apr_dbm_db}
BuildRequires:  db-devel
%endif

%if %{build_apr_dbd_pgsql}
# stupid postgresql... stupid build system...
# this is needed due to the postgresql packaging and due to bugs like this:
# https://qa.mandriva.com/show_bug.cgi?id=52527
%define postgresql_version %(pg_config &>/dev/null && pg_config 2>/dev/null | grep "^VERSION" | awk '{ print $4 }' 2>/dev/null | sed -re 's/rc[0-9]+$//' || echo 0)
%endif

%description
The mission of the Apache Portable Runtime (APR) is to provide a
free library of C data structures and routines.  This library
contains additional utility interfaces for APR; including support
for XML, LDAP, database interfaces, URI parsing and more.

%package -n     %{libname}
Summary:        Apache Portable Runtime Utility library
Group:          System/Libraries
Provides:       %{name} = %{version}-%{release}
Provides:       lib%{name} = %{version}-%{release}
Obsoletes:      lib%{name} %{name}
Obsoletes:      %{_lib}apr-util1 < %{version}-%{release}

%description -n %{libname}
The mission of the Apache Portable Runtime (APR) is to provide a
free library of C data structures and routines.  This library
contains additional utility interfaces for APR; including support
for XML, LDAP, database interfaces, URI parsing and more.

You can build %{name} with some conditional build swithes;

(ie. use with rpm --rebuild):

--with[out] apr_dbd_ldap        apr_dbd_ldap support (enabled)
--with[out] apr_dbd_freetds     apr_dbd_freetds support (enabled)
--with[out] apr_dbd_mysql       apr_dbd_mysql support (enabled)
--with[out] apr_dbd_oracle      apr_dbd_oracle support (disabled)
--with[out] apr_dbd_pgsql       apr_dbd_pgsql support (enabled)
--with[out] apr_dbd_sqlite3     apr_dbd_sqlite3 support (enabled)
--with[out] apr_dbd_odbc        apr_dbd_odbc support (enabled)
--with[out] apr_dbm_db          apr_dbm_db support (enabled)

%if %{build_apr_dbd_ldap}
%package        dbd-ldap
Summary:        DBD driver for OpenLDAP
Group:          System/Libraries
License:        Apache License
Requires:       %{libname} >= %{version}-%{release}

%description    dbd-ldap
DBD driver for OpenLDAP.
%endif

%if %{build_apr_dbd_pgsql}
%package        dbd-pgsql
Summary:        DBD driver for PostgreSQL
Group:          System/Libraries
License:        Apache License
Requires:       %{libname} >= %{version}-%{release}
Requires:       postgresql-libs >= %{postgresql_version}

%description    dbd-pgsql
DBD driver for PostgreSQL.
%endif

%if %{build_apr_dbd_mysql}
%package        dbd-mysql
Summary:        DBD driver for MySQL
Group:          System/Libraries
License:        Apache License
Requires:       %{libname} >= %{version}-%{release}

%description    dbd-mysql
DBD driver for MySQL.
%endif

%if %{build_apr_dbd_sqlite3}
%package        dbd-sqlite3
Summary:        DBD driver for SQLite 3
Group:          System/Libraries
License:        Apache License
Requires:       %{libname} >= %{version}-%{release}

%description    dbd-sqlite3
DBD driver for SQLite 3.
%endif

%if %{build_apr_dbd_freetds}
%package        dbd-freetds
Summary:        DBD driver for FreeTDS
Group:          System/Libraries
License:        Apache License
Requires:       %{libname} >= %{version}-%{release}

%description    dbd-freetds
DBD driver for FreeTDS.
%endif

%if %{build_apr_dbd_oracle}
%package        dbd-oracle
Summary:        DBD driver for Oracle
Group:          System/Libraries
License:        Apache License
Requires:       %{libname} >= %{version}-%{release}

%description    dbd-oracle
DBD driver for Oracle.
%endif

%if %{build_apr_dbd_odbc}
%package        dbd-odbc
Summary:        DBD driver for unixODBC
Group:          System/Libraries
License:        Apache License
Requires:       %{libname} >= %{version}-%{release}

%description    dbd-odbc
DBD driver for unixODBC.
%endif

%if %{build_apr_dbm_db}
%package        dbm-db
Summary:        DBD driver for Berkley BD
Group:          System/Libraries
License:        Apache License
Requires:       %{libname} >= %{version}-%{release}

%description    dbm-db
DBD driver for Berkley BD.
%endif

%package        openssl
Summary:        APR utility library OpenSSL crypto support
Group:          System/Libraries
Requires:       %{libname} >= %{version}-%{release}

%description    openssl
This package provides the OpenSSL crypto support for apr-util.

%package        nss
Summary:        APR utility library NSS crypto support
Group:          System/Libraries
Requires:       %{libname} >= %{version}-%{release}

%description    nss
This package provides the NSS crypto support for apr-util.

%package -n     %{develname}
Summary:        APR utility library development kit
Group:          Development/C
Requires:       %{name} >= %{version}
Requires:       %{libname} >= %{version}-%{release}
Requires:       apr-util = %{version}
Requires:       apr-devel
Requires:       openldap-devel
Requires:       expat-devel
Provides:       %{mklibname apr-util -d 1} = %{version}-%{release}
Obsoletes:      %{mklibname apr-util -d 1}
Provides:       %{name}-devel = %{version}-%{release}
Obsoletes:      %{name}-devel

%description -n %{develname}
This package provides the support files which can be used to 
build applications using the APR utility library.  The mission 
of the Apache Portable Runtime (APR) is to provide a free 
library of C data structures and routines.

%prep
%setup -q -n %{name}-%{version}
%patch0 -p1 -b .config
%patch1 -p0 -b .link
%patch2 -p0 -b .linkage_fix

cat >> config.layout << EOF
<Layout NUX>
    prefix:        %{_prefix}
    exec_prefix:   %{_prefix}
    bindir:        %{_bindir}
    sbindir:       %{_sbindir}
    libdir:        %{_libdir}
    libexecdir:    %{_libexecdir}
    mandir:        %{_mandir}
    infodir:       %{_infodir}
    includedir:    %{_includedir}/apr-%{apuver}
    sysconfdir:    %{_sysconfdir}
    datadir:       %{_datadir}
    installbuilddir: %{_libdir}/apr-%{apuver}/build
    localstatedir: /var
    runtimedir:    /var/run
    libsuffix:     -\${APRUTIL_MAJOR_VERSION}
</Layout>
EOF

%build
%serverbuild

# We need to re-run ./buildconf because of any applied patch(es)
#./buildconf --with-apr=%{_prefix}

# buildconf is borked...
cp %{_libdir}/apr-%{apuver}/build/apr_common.m4 %{_libdir}/apr-%{apuver}/build/find_apr.m4 %{_libdir}/apr-%{apuver}/build/gen-build.py build/

# conditional lib64 hack
%if "%{_lib}" != "lib"
perl -pi -e "s|/lib\b|/%{_lib}|g" build/*.m4
%endif

export WANT_AUTOCONF_2_5=1
rm -f configure
libtoolize --copy --force; aclocal; autoconf --force
python build/gen-build.py make

%{__sed} -i -e '/OBJECTS_all/s, dbd/apr_dbd_[^ ]*\.lo,,g' build-outputs.mk

# force values that may produce wrong results
export apu_have_sqlite2='0'
cat >> config.cache << EOF
ac_cv_header_sqlite_h=no
ac_cv_lib_sqlite_sqlite_open=no
ac_cv_ldap_set_rebind_proc_style=three
EOF

%configure2_5x \
    --cache-file=config.cache \
    --with-apr=%{_prefix} \
    --includedir=%{_includedir}/apr-%{apuver} \
    --with-installbuilddir=%{_libdir}/apr-%{apuver}/build \
    --enable-layout=NUX \
%if %{build_apr_dbd_ldap}
    --with-ldap \
%endif
%if %{build_apr_dbd_freetds}
    --with-freetds=%{_prefix} \
%endif
%if %{build_apr_dbd_mysql}
    --with-mysql=%{_prefix} \
%endif
%if %{build_apr_dbd_oracle}
    --with-oracle \
%endif
%if %{build_apr_dbd_pgsql}
    --with-pgsql=%{_prefix} \
%endif
%if %{build_apr_dbd_sqlite3}
    --with-sqlite3=%{_prefix} \
%endif
%if %{build_apr_dbd_odbc}
    --with-odbc=%{_prefix} \
%endif
%if %{build_apr_dbm_db}
    --with-berkeley-db \
%endif
    --without-sqlite2 \
    --without-gdbm \
    --with-crypto --with-openssl=%{_prefix} --with-nss=%{_prefix}

%make
make dox

%install
%makeinstall_std

# Documentation
rm -rf html; cp -rp docs/dox/html html

# drop .la files
find %{buildroot} -name '*.la' -delete

# multiarch anti-borker
perl -pi -e "s|^LDFLAGS=.*|LDFLAGS=\"\"|g" %{buildroot}%{_bindir}/apu-%{apuver}-config

# includes anti-borker
perl -pi -e "s|-I%{_includedir}/mysql||g" %{buildroot}%{_bindir}/apu-%{apuver}-config

# Unpackaged files
rm -f %{buildroot}%{_libdir}/aprutil.exp

%files -n %{libname}
%doc CHANGES LICENSE
%{_libdir}/libaprutil-%{apuver}.so.%{major}
%{_libdir}/libaprutil-%{apuver}.so.%{major}.*
%dir %{_libdir}/apr-util-%{apuver}

%files -n %{develname}
%doc html
%attr(0755,root,root) %{_bindir}/apu-%{apuver}-config
%{_includedir}/apr-%{apuver}/*.h
%{_libdir}/libaprutil-%{apuver}.so
%{_libdir}/pkgconfig/*.pc

%if %{build_apr_dbd_ldap}
%files dbd-ldap
%attr(0755,root,root) %{_libdir}/apr-util-%{apuver}/apr_ldap*.so
%endif

%if %{build_apr_dbd_mysql}
%files dbd-mysql
%attr(0755,root,root) %{_libdir}/apr-util-%{apuver}/apr_dbd_mysql*.so
%endif

%if %{build_apr_dbd_pgsql}
%files dbd-pgsql
%attr(0755,root,root) %{_libdir}/apr-util-%{apuver}/apr_dbd_pgsql*.so
%endif

%if %{build_apr_dbd_sqlite3}
%files dbd-sqlite3
%attr(0755,root,root) %{_libdir}/apr-util-%{apuver}/apr_dbd_sqlite3*.so
%endif

%if %{build_apr_dbd_freetds}
%files dbd-freetds
%attr(0755,root,root) %{_libdir}/apr-util-%{apuver}/apr_dbd_freetds*.so
%endif

%if %{build_apr_dbd_oracle}
%files dbd-oracle
%attr(0755,root,root) %{_libdir}/apr-util-%{apuver}/apr_dbd_oracle*.so
%endif

%if %{build_apr_dbd_odbc}
%files dbd-odbc
%attr(0755,root,root) %{_libdir}/apr-util-%{apuver}/apr_dbd_odbc*.so
%endif

%if %{build_apr_dbm_db}
%files dbm-db
%attr(0755,root,root) %{_libdir}/apr-util-%{apuver}/apr_dbm_db*.so
%endif

%files openssl
%attr(0755,root,root) %{_libdir}/apr-util-%{apuver}/apr_crypto_openssl*.so

%files nss
%attr(0755,root,root) %{_libdir}/apr-util-%{apuver}/apr_crypto_nss*.so


%changelog
* Tue Nov 25 2014 cjw <cjw> 1.5.4-4.mga5
+ Revision: 799274
- fix postgresql-libs dependency version for postgresql release candidates

* Tue Nov 25 2014 cjw <cjw> 1.5.4-3.mga5
+ Revision: 798919
- rebuild against postgresql9.4

* Wed Oct 15 2014 umeabot <umeabot> 1.5.4-2.mga5
+ Revision: 747256
- Second Mageia 5 Mass Rebuild

* Wed Oct 08 2014 luigiwalser <luigiwalser> 1.5.4-1.mga5
+ Revision: 737584
- 1.5.4

* Sat Sep 27 2014 tv <tv> 1.5.3-3.mga5
+ Revision: 725947
- rebuild for missing pythoneggs deps

* Tue Sep 16 2014 umeabot <umeabot> 1.5.3-2.mga5
+ Revision: 677872
- Mageia 5 Mass Rebuild

* Thu Dec 05 2013 luigiwalser <luigiwalser> 1.5.3-1.mga4
+ Revision: 555406
- 1.5.3

* Sat Oct 19 2013 umeabot <umeabot> 1.5.2-2.mga4
+ Revision: 523699
- Mageia 4 Mass Rebuild

* Fri May 24 2013 shlomif <shlomif> 1.5.2-1.mga4
+ Revision: 426440
- New version 1.5.2
- Retab

* Fri Jan 11 2013 umeabot <umeabot> 1.5.1-3.mga3
+ Revision: 345961
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Wed Dec 26 2012 pterjan <pterjan> 1.5.1-2.mga3
+ Revision: 335365
- Fix doc files list for new rpm

* Tue Dec 04 2012 oden <oden> 1.5.1-1.mga3
+ Revision: 326425
- 1.5.1

* Sun Aug 19 2012 luigiwalser <luigiwalser> 1.4.1-6.mga3
+ Revision: 282296
- enable mysql

* Tue Jul 31 2012 fwang <fwang> 1.4.1-5.mga3
+ Revision: 276365
- rebuild for db-5.3

* Tue Mar 27 2012 luigiwalser <luigiwalser> 1.4.1-4.mga3
+ Revision: 227160
- fix obsoleted library version
- update config patch (from mdv)

* Sun Feb 12 2012 luigiwalser <luigiwalser> 1.4.1-2.mga2
+ Revision: 208265
- build against current db version
- add crypto support (from mdv)

* Mon Jan 09 2012 shlomif <shlomif> 1.4.1-1.mga2
+ Revision: 194064
- New version - apr-util-1.4.1

* Sun Dec 11 2011 fwang <fwang> 1.3.12-4.mga2
+ Revision: 180602
- correct libname

* Sun Dec 11 2011 fwang <fwang> 1.3.12-3.mga2
+ Revision: 180573
- do not perform check at all
- force use so

* Sun Dec 11 2011 fwang <fwang> 1.3.12-2.mga2
+ Revision: 180543
- force success
- drop .la files
- New version 1.3.12 (drop merged patch)

* Wed Jan 12 2011 ahmad <ahmad> 1.3.10-8.mga1
+ Revision: 7654
- drop old/unneeded scriptlets
- disable mysql for now
- imported package apr-util

